package tugas_pbo_10;

import javax.swing.JOptionPane;
/**
 *
 * @author DINA NAINGGOLAN
 */
public class Registration extends javax.swing.JFrame {
    DataMahasiswa mhs = new DataMahasiswa();
    /**
     * Creates new form Registration
     */
    public Registration() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        umurTextField = new javax.swing.JTextField();
        nimTextField = new javax.swing.JTextField();
        fnameTextField = new javax.swing.JTextField();
        lnameTextField = new javax.swing.JTextField();
        asalComboBox = new javax.swing.JComboBox<>();
        nimErrorLabel = new javax.swing.JLabel();
        namaErrorLabel = new javax.swing.JLabel();
        umurErrorLabel = new javax.swing.JLabel();
        resetButton = new javax.swing.JButton();
        simpanButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jPanel1.setBackground(new java.awt.Color(255, 255, 255));

        jLabel5.setFont(new java.awt.Font("Segoe UI", 1, 12)); // NOI18N
        jLabel5.setText("Student Form");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel5)
                .addContainerGap(267, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jLabel5)
                .addContainerGap())
        );

        getContentPane().add(jPanel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 350, 30));

        jLabel1.setFont(new java.awt.Font("Segoe UI", 1, 12)); // NOI18N
        jLabel1.setText("NIM:");
        getContentPane().add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 40, -1, -1));

        jLabel2.setFont(new java.awt.Font("Segoe UI", 1, 12)); // NOI18N
        jLabel2.setText("Nama:");
        getContentPane().add(jLabel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 90, -1, -1));

        jLabel3.setFont(new java.awt.Font("Segoe UI", 1, 12)); // NOI18N
        jLabel3.setText("Umur:");
        getContentPane().add(jLabel3, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 140, -1, -1));

        jLabel4.setFont(new java.awt.Font("Segoe UI", 1, 12)); // NOI18N
        jLabel4.setText("Asal:");
        getContentPane().add(jLabel4, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 190, -1, 20));

        umurTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                umurTextFieldActionPerformed(evt);
            }
        });
        umurTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                umurTextFieldKeyPressed(evt);
            }
        });
        getContentPane().add(umurTextField, new org.netbeans.lib.awtextra.AbsoluteConstraints(240, 130, 40, -1));

        nimTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                nimTextFieldActionPerformed(evt);
            }
        });
        nimTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                nimTextFieldKeyPressed(evt);
            }
        });
        getContentPane().add(nimTextField, new org.netbeans.lib.awtextra.AbsoluteConstraints(60, 40, 220, -1));

        fnameTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fnameTextFieldActionPerformed(evt);
            }
        });
        fnameTextField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                fnameTextFieldKeyPressed(evt);
            }
        });
        getContentPane().add(fnameTextField, new org.netbeans.lib.awtextra.AbsoluteConstraints(60, 90, 120, -1));

        lnameTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                lnameTextFieldActionPerformed(evt);
            }
        });
        getContentPane().add(lnameTextField, new org.netbeans.lib.awtextra.AbsoluteConstraints(180, 90, 100, -1));

        asalComboBox.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Jakarta", "Bogor", "Depok", "Tanggerang", "Bekasi" }));
        asalComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                asalComboBoxActionPerformed(evt);
            }
        });
        getContentPane().add(asalComboBox, new org.netbeans.lib.awtextra.AbsoluteConstraints(60, 190, 220, -1));

        nimErrorLabel.setForeground(new java.awt.Color(255, 51, 51));
        getContentPane().add(nimErrorLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(60, 60, 220, 30));

        namaErrorLabel.setForeground(new java.awt.Color(255, 51, 51));
        getContentPane().add(namaErrorLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(60, 116, 290, 20));

        umurErrorLabel.setForeground(new java.awt.Color(255, 51, 51));
        getContentPane().add(umurErrorLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(190, 160, 150, 30));

        resetButton.setBackground(new java.awt.Color(153, 204, 255));
        resetButton.setFont(new java.awt.Font("Segoe UI", 1, 12)); // NOI18N
        resetButton.setText("Reset");
        resetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                resetButtonActionPerformed(evt);
            }
        });
        getContentPane().add(resetButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 230, 130, -1));

        simpanButton.setBackground(new java.awt.Color(153, 204, 255));
        simpanButton.setFont(new java.awt.Font("Segoe UI", 1, 12)); // NOI18N
        simpanButton.setText("Simpan");
        simpanButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                simpanButtonActionPerformed(evt);
            }
        });
        getContentPane().add(simpanButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(140, 230, 140, -1));

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 280, Short.MAX_VALUE)
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 50, Short.MAX_VALUE)
        );

        getContentPane().add(jPanel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 220, 280, 50));

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void fnameTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fnameTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_fnameTextFieldActionPerformed

    private void asalComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_asalComboBoxActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_asalComboBoxActionPerformed

    private void lnameTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_lnameTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_lnameTextFieldActionPerformed

    private void resetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_resetButtonActionPerformed
        // TODO add your handling code here: 
        nimTextField.setText(null);
        fnameTextField.setText(null);
        lnameTextField.setText(null);
        umurTextField.setText(null);
    }//GEN-LAST:event_resetButtonActionPerformed
        public boolean cekKosong(String inputan){
        if(inputan.equals("")){
            return true;
        }else
            return false;
    }
    
    public boolean cekOver(int digit, int batas){
        if(digit>batas){
            return true;
        }else
            return false;
    }
    
    private void simpanButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_simpanButtonActionPerformed
        // TODO add your handling code here:
        String nim = nimTextField.getText();
        int digitNIM = nimTextField.getText().length();
        String fname = fnameTextField.getText();
        String lname = lnameTextField.getText();
        String name = fname+" "+lname;
        int digitNama = fname.length()+lname.length();
        String umur = umurTextField.getText();
        int digitUmur = umurTextField.getText().length();
        String asal = asalComboBox.getSelectedItem().toString();
        boolean validasiKosong = (cekKosong(nim)||cekKosong(fname)||cekKosong(lname)||cekKosong(umur));
        boolean validasiDigit = (cekOver(digitNIM,6)||cekOver(digitUmur,3)||cekOver(digitNama,50));
        boolean invalid =  (validasiKosong||validasiDigit);
        
        //Cek kosong
        if(validasiKosong){
            if(cekKosong(nim)){
                JOptionPane.showMessageDialog(null, "NIM wajib diisi!");
                //System.out.println("Terjadi kesalahan input: NIM kosong");
            }
            if(cekKosong(fname)){
                JOptionPane.showMessageDialog(null, "Nama depan wajib diisi!");
                //System.out.println("Terjadi kesalahan input: Nama depan kosong");
            }
            if(cekKosong(lname)){
                JOptionPane.showMessageDialog(null, "Nama belakang wajib diisi!");
                //System.out.println("Terjadi kesalahan input: Nama belakang kosong");
            }
        
            if(cekKosong(umur)){
                JOptionPane.showMessageDialog(null, "Umur wajib diisi!");
                //System.out.println("Terjadi kesalahan input: Umur kosong");
            }
        }
        
        //Cek digit
        if(validasiDigit){
            if(cekOver(digitNIM,6)){
                JOptionPane.showMessageDialog(null, "Terjadi kesalahan input: NIM lebih dari 6 digit");
                System.out.println("Digit NIM: " + digitNIM);
            }
            if(cekOver(digitUmur,3)){
                JOptionPane.showMessageDialog(null, "Terjadi kesalahan input: Umur Anda tidak wajar");
                System.out.println("Digit umur: " + digitUmur);
            }
            if(cekOver(digitNama,50)){
                JOptionPane.showMessageDialog(null, "Terjadi kesalahan input: Nama lebih dari 50 karakter");
                System.out.println("Jumlah karakter: " + digitNama);
            }
        }
        if(invalid==true){
            System.out.println("Data tidak valid");
        }
        else{
            System.out.println("Data valid");
            System.out.println("Daftar NIM dan Nama Mahasiswa yang telah berhasil disimpan :");
            mhs.tambahMahasiswa(new Mahasiswa(nim, name, umur, asal));
            mhs.tampilMahasiswa();
        }
    }//GEN-LAST:event_simpanButtonActionPerformed

    private void umurTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_umurTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_umurTextFieldActionPerformed

    private void nimTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_nimTextFieldActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_nimTextFieldActionPerformed

    private void umurTextFieldKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_umurTextFieldKeyPressed
        // TODO add your handling code here:
        char c = evt.getKeyChar();
        int digitUmur = umurTextField.getText().length() + 1;
        if(Character.isLetter(c)){
            umurTextField.setEditable(false);
            umurErrorLabel.setText("Silakan input Angka");
        }
        else{
            umurTextField.setEditable(true);
            if (digitUmur>3){
                umurErrorLabel.setText("Anda terlalu tua");
            }
            else{
             umurErrorLabel.setText("");
            }
        }
    }//GEN-LAST:event_umurTextFieldKeyPressed

    private void nimTextFieldKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_nimTextFieldKeyPressed
        // TODO add your handling code here:
         char c = evt.getKeyChar();
        int digit = nimTextField.getText().length() + 1;
        if(Character.isLetter(c)){
            nimTextField.setEditable(false);
            nimErrorLabel.setText("Silakan input Angka");
        }else{
            nimTextField.setEditable(true);
            if (digit>6){
                nimErrorLabel.setText("NIM harus terdiri dari 6 digit");
            }else{
                nimTextField.setEditable(true);
                nimErrorLabel.setText("");
            }
        }
    }//GEN-LAST:event_nimTextFieldKeyPressed

    private void fnameTextFieldKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_fnameTextFieldKeyPressed
        // TODO add your handling code here:
        namaErrorLabel.setText("nama depan + nama belakang max 50 karakter");
    }//GEN-LAST:event_fnameTextFieldKeyPressed
  
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Registration.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Registration.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Registration.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Registration.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Registration().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox<String> asalComboBox;
    private javax.swing.JTextField fnameTextField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JTextField lnameTextField;
    private javax.swing.JLabel namaErrorLabel;
    private javax.swing.JLabel nimErrorLabel;
    private javax.swing.JTextField nimTextField;
    private javax.swing.JButton resetButton;
    private javax.swing.JButton simpanButton;
    private javax.swing.JLabel umurErrorLabel;
    private javax.swing.JTextField umurTextField;
    // End of variables declaration//GEN-END:variables
}
